      __      __                                            __   __   ______
     /\ \  __/\ \                                          /\ \ /\ \ /\__  _\
     \ \ \/\ \ \ \     __     __     _____     ___     ___ \ `\`\/'/'\/_/\ \/
      \ \ \ \ \ \ \  /'__`\ /'__`\  /\ '__`\  / __`\ /' _ `\`\/ > <     \ \ \
       \ \ \_/ \_\ \/\  __//\ \L\.\_\ \ \L\ \/\ \L\ \/\ \/\ \  \/'/\`\   \_\ \__
        \ `\___x___/\ \____\ \__/.\_\\ \ ,__/\ \____/\ \_\ \_\ /\_\\ \_\ /\_____\
         '\/__//__/  \/____/\/__/\/_/ \ \ \/  \/___/  \/_/\/_/ \/_/ \/_/ \/_____/
                                       \ \_\
                                        \/_/
             __         ___
            /\ \__  __ /\_ \           __
      __  __\ \ ,_\/\_\\//\ \    __  _/\_\
     /\ \/\ \\ \ \/\/\ \ \ \ \  /\ \/'\/\ \
     \ \ \_\ \\ \ \_\ \ \ \_\ \_\/>  </\ \ \                                     
      \ \____/ \ \__\\ \_\/\____\/\_/\_\\ \_\
       \/___/   \/__/ \/_/\/____/\//\/_/ \/_/



![Stable](http://weaponxi.com/design_images/stable.png)
-------

###### utilxi - Utility library that extends underscore

## Functions

There are two types of functions, ones that are available for client-side [web] and server-side [node]. The ones for client-side are also available for server-side.

[Underscore Functions](http://documentcloud.github.com/underscore/) and these:


### merge `[web]` : 

Taken from [deepmerge package by nrf110](https://github.com/nrf110/deepmerge), a function that deeply merges objects. Right side overwrites left side.

```javascript
// Usage
var x = { foo: { bar: 3 },
  array: [ { does: 'work', too: [ 1, 2, 3 ] },{ really: 'yes' } ] }
var y = { foo: { baz: 4 },
  quux: 5,
  array: [ { does: 'work', too: [ 3,4, 5, 6 ] }, { really: 'ysee' } ] }

  _.merge(x,y)
// would result
{
    "foo": {
        "bar": 3,
        "baz": 4
    },
    "array": [
        {
            "does": "work",
            "too": [
                1,
                2,
                3,
                3,
                4,
                5,
                6
            ]
        },
        {
            "really": "ysee"
        }
    ],
    "quux": 5
}
```

### capitalize `[web]` :

Capitalizes the first letter of string.
```javascript
  console.log(_.capitalize("fabio"));
  // Fabio
```
### root `[node]` : 
Gives the root directory of the node project, absolutely.
```javascript
console.log(_.root());
// /home/logan/projects/npm-utilxi
```

## Changelog

#### 20/Jan/2013 v1.1.5
* Using browserfy to make only one for web and node
* `lib/utilxi.js` is for web and src/utilxi.coffee is for node.
* index.js requires src/utilxi.coffee so removing src from .npmignore

#### 13/Jan/2013 v1.1.4
* fixed _.root() method because of the directory changes in node and web versions

#### 05/Jan/2013 v1.1.3

* moved underscore back to dependencies.

#### 05/Jan/2013 v1.1.0
* made two versions one for node and one for web.
* embeded deepmerge to utilxi as `_.merge` method. credit goes to https://github.com/nrf110/deepmerge
* removed deepmerge from dependecies.
* Converted code to coffeescript
* added grunt file.
* added prepublish script
* moved test to test folder
* moved underscore to dev dependencies
* web version also has minified version.

#### 25/Dec/2012 v1.0.43:
* Moved repo to WeaponXI organization
* Cleaned up unnecessary files.

#### 16/Dec/2012 v1.0.4 :
* Added deepmerge as dependency
* Added _.merge(x,y) to underscore as a mixin -- which is an alias for deepmerge(x,y).

#### 16/Dec/2012 v1.0.3 :
* Added _.root() function as a mixin -- it tells the root of the project directory, as an absolute path.
